<?php
function ShowClaim(){
  $id = (int)substr($_GET['id'], 0, 7); // id жалобы

  if ($GLOBALS['islogged']){ //если юзер залогинен берём его настройки отображения контента
    $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT timezone, timeformat FROM users WHERE iduser=? LIMIT 1');
    mysqli_stmt_bind_param($stmt, "i", intval($_COOKIE['iduser'])); 
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $timezone, $timeformat);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);
  }else{
    $timezone = (int)$_COOKIE['timeshift']; // пробуем взять данные из куков
    if (($timezone < -12) or ($timezone > 12)) $timezone = 0;
    $timeformat = 'H:i d.m.Y';
  }

  $stmt = mysqli_prepare($GLOBALS['DB'],
  'SELECT claims.id_from, claims.id_to, claims.type, claims.text, claims.createtime, claims.status, b1.name, b2.name, votes.vote
   FROM claims
   LEFT JOIN users AS b1 ON claims.id_from = b1.iduser
   LEFT JOIN users AS b2 ON claims.id_to = b2.iduser
   LEFT JOIN votes ON votes.id_claim=? AND votes.id_from=?
   WHERE claims.id_claim=? AND claims.type=1
   UNION
   SELECT claims.id_from, claims.id_to, claims.type, claims.text, claims.createtime, claims.status, b1.name, b2.name, votes.vote
   FROM claims
   LEFT JOIN users AS b1 ON claims.id_from = b1.iduser
   LEFT JOIN topics AS b2 ON claims.id_to = b2.id_topic
   LEFT JOIN votes ON votes.id_claim=? AND votes.id_from=?
   WHERE claims.id_claim=? AND claims.type=2
   UNION
   SELECT claims.id_from, claims.id_to, claims.type, claims.text, claims.createtime, claims.status, b1.name, b2.id_msg, votes.vote
   FROM claims
   LEFT JOIN users AS b1 ON claims.id_from = b1.iduser
   LEFT JOIN posts AS b2 ON claims.id_to = b2.id_msg
   LEFT JOIN votes ON votes.id_claim=? AND votes.id_from=?
   WHERE claims.id_claim=? AND claims.type=3
   LIMIT 1');
  mysqli_stmt_bind_param($stmt, 'iiiiiiiii', $id, intval($_COOKIE['iduser']), $id, $id, intval($_COOKIE['iduser']), $id, $id, intval($_COOKIE['iduser']), $id); 
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $id_from, $id_to, $type, $text, $createtime, $status, $name, $nameto, $myvote);
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);

  if (!empty($id_from)){
    $html = file_get_contents('./templates/Claim.html');

    $html ='<table width="100%" style="background-color: #ffffff; font-size: 16px; font-weight: 600"><tr><td height="2px"></td></tr>
    <tr><td><div align="center">Жалоба</div></td></tr>
    <tr><td height="4px"></td></tr></table>'.$html; //заголовок страницы

    $title = '<a title="Перейти на страницу участника" style="font-size: 16px; font-weight: 600" href="./?ai=50&id='.$id_from.'">'.$name.'</a>';
    $title .= ' против ';
    switch ($type){
      case 1: 
        $title .= ' участника ';
        $title .='<a title="Перейти на страницу участника" style="font-size: 16px; font-weight: 600" href="./?ai=50&id='.$id_to.'">'.$nameto.'</a>';
        break;
      case 2: 
        $title .= ' топика ';
        $title .= '<a title="Перейти в топик" style="font-size: 16px; font-weight: 600" href="./?ai=9&id='.$id_to.'">"'.$nameto.'"</a>';
        break;
      case 3: 
        $title .= ' сообщения ';
        $title .= '<a title="Перейти на сообщение" style="font-size: 16px; font-weight: 600" href="./?ai=9&msg='.$id_to.'#'.$id_to.'">№'.$nameto.'</a>';
        break;
    }

    $date = date_create($createtime); //для отображения смещаем время на указанное в настройках количество часов
    if ($timezone < 0){
      $timeshift = abs($timezone);
      date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
    }else{
      date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
    }
    $createtime = date_format($date, $timeformat);
    $html = str_replace('{createtime}', $createtime, $html);
    
    $html = str_replace('{title}', $title, $html);
    require('TagFormat.php');
    $html = str_replace('{text}', TagFormat($text), $html);
    $html = str_replace('{id_claim}', $id, $html);

    if (empty($myvote) and ($status == 'vote')){ //если участник ещё не голосовал за жалобу и голосование продолжается
      $html = str_replace('{yes}', '', $html);
      $html = str_replace('{abs}', '', $html);
      $html = str_replace('{no}', '', $html);
      $html = str_replace('{yeslist}', '', $html);
      $html = str_replace('{abslist}', '', $html);
      $html = str_replace('{nolist}', '', $html);
      $html = str_replace('{votebut}', "<button type='button' style='font-weight: 600; font-size: 15px; width: 140px' onclick='VoteClaim()'>Проголосовать</button>", $html);
      $html = str_replace('{ch1}', '<input type="radio" name="vote" id="ch1">', $html);
      $html = str_replace('{ch2}', '<input type="radio" name="vote" id="ch2">', $html);
      $html = str_replace('{ch3}', '<input type="radio" name="vote" id="ch3">', $html);
    }else{//если участник уже голосовал за жалобу
      $list = ''; //подсчитываем количество проголосовавших "За"
      $stmt = mysqli_prepare($GLOBALS['DB'], 
      'SELECT votes.id_from, users.name FROM votes LEFT JOIN users ON votes.id_from = users.iduser
       WHERE votes.id_claim=? AND votes.vote=1 ORDER BY votes.createtime DESC');
      mysqli_stmt_bind_param($stmt, 'i', $id); 
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $id_from, $name);
      mysqli_stmt_store_result($stmt);
      $num = mysqli_stmt_num_rows($stmt);
      $num1 = $num;
      while (mysqli_stmt_fetch($stmt)){
        $num = $num - 1;
        $item = "<a title='Перейти на страницу участника' href='./?ai=50&id=".$id_from."'>".$name."</a>";
        if ($num > 0) $list .= $item."<br>";
        else $list .= $item; //к последнему имени перенос не добавляем
      }
      mysqli_stmt_close($stmt);
      $html = str_replace('{yeslist}', $list, $html);

      $list = '';//подсчитываем количество воздержавшихся
      $stmt = mysqli_prepare($GLOBALS['DB'], 
      'SELECT votes.id_from, users.name FROM votes LEFT JOIN users ON votes.id_from = users.iduser
       WHERE votes.id_claim=? AND votes.vote=2 ORDER BY votes.createtime DESC');
      mysqli_stmt_bind_param($stmt, 'i', $id); 
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $id_from, $name);
      mysqli_stmt_store_result($stmt);
      $num = mysqli_stmt_num_rows($stmt);
      $num2 = $num;
      while (mysqli_stmt_fetch($stmt)){
        $num = $num - 1;
        $item = "<a title='Перейти на страницу участника' href='./?ai=50&id=".$id_from."'>".$name."</a>";
        if ($num > 0) $list .= $item."<br>";
        else $list .= $item; //к последнему имени перенос не добавляем
      }
      mysqli_stmt_close($stmt);
      $html = str_replace('{abslist}', $list, $html);

      $list = '';//подсчитываем количество проголосовавших "против"
      $stmt = mysqli_prepare($GLOBALS['DB'], 
      'SELECT votes.id_from, users.name FROM votes LEFT JOIN users ON votes.id_from = users.iduser
       WHERE votes.id_claim=? AND votes.vote=3 ORDER BY votes.createtime DESC');
      mysqli_stmt_bind_param($stmt, 'i', $id); 
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $id_from, $name);
      mysqli_stmt_store_result($stmt);
      $num = mysqli_stmt_num_rows($stmt);
      $num3 = $num;
      while (mysqli_stmt_fetch($stmt)){
        $num = $num - 1;
        $item = "<a title='Перейти на страницу участника' href='./?ai=50&id=".$id_from."'>".$name."</a>";
        if ($num > 0) $list .= $item."<br>";
        else $list .= $item; //к последнему имени перенос не добавляем
      }
      mysqli_stmt_close($stmt);
      $html = str_replace('{nolist}', $list, $html);

      $sum = $num1 + $num2 + $num3;
      if ($sum == 0){
        $html = str_replace('{yes}', str_replace('.',',','0%'), $html);
        $html = str_replace('{abs}', str_replace('.',',','0%'), $html);
        $html = str_replace('{no}', str_replace('.',',','0%'), $html);  
      }else{
        $html = str_replace('{yes}', str_replace('.',',',round(100*($num1/$sum),1,PHP_ROUND_HALF_UP).'%'), $html);
        $html = str_replace('{abs}', str_replace('.',',',round(100*($num2/$sum),1,PHP_ROUND_HALF_UP).'%'), $html);
        $html = str_replace('{no}', str_replace('.',',',round(100*($num3/$sum),1,PHP_ROUND_HALF_UP).'%'), $html);        
      }
      $html = str_replace('{votebut}', '', $html);
      $html = str_replace('{ch1}', '', $html);
      $html = str_replace('{ch2}', '', $html);
      $html = str_replace('{ch3}', '', $html);
    }
    return $html;
  }else{ //если такой жалобы нет, переходим на список жалоб
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=40');
    else header('Location: http://'.$GLOBALS['HostName'].'/?ai=40');  
  }
}
?>