<?php
function ShowNewMSGForm(){
  if ($GLOBALS['islogged']){ //если есть логин
    if (isset($_SESSION['NewMsgForm'])){ // если форма уже была заполнена но с ошибками, все данные берём из сессии
      $error = $_SESSION['NewMsgForm']['error'];
      $message = $_SESSION['NewMsgForm']['message'];
      unset($_SESSION['NewMsgForm']);
    }else{ //в противном случае все поля пустые
      $error = '';
      $message = '';
    }
  }else{ //если логона нету
    $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
      <tr><td><div align="center">Авторизуйтесь, чтобы создавать сообщения на форуме.</div></td></tr><tr><td height="10px"></td></tr></table>';  
    return $html; //не используем сообщения ai=200 чтобы после авторизации вернуться на ту же страницу
    exit();
  }

  $id = (int)substr($_GET['id'], 0, 6); //на всякий случай ограничиваем длину id-топика
  $msg = (int)substr($_GET['msg'], 0, 7); //на всякий случай ограничиваем длину id цитируемого сообщения

  $stmt = mysqli_prepare($GLOBALS['DB'], "SELECT name, id_author, type, deleted FROM topics WHERE id_topic=? LIMIT 1"); //проверяем есть ли топик
  mysqli_stmt_bind_param($stmt, 'i', $id);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $name, $id_author, $type, $del); //данные топика
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);
  if (!isset($name)){
    $_SESSION['msg'] = 'Такого топика нет.';
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=200');
    else header('Location: http://'.$GLOBALS['HostName'].'/?ai=200');
    exit();
  }

  if ($del == 1){
    $_SESSION['msg'] = 'Топик удалён.';
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=200');
    else header('Location: http://'.$GLOBALS['HostName'].'/?ai=200');
    exit();
  }

  $stmt = mysqli_prepare($GLOBALS['DB'], "SELECT status, deleted, name, avatar FROM users WHERE iduser=? LIMIT 1");
  mysqli_stmt_bind_param($stmt, 'i', intval($_COOKIE['iduser']));
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $status, $deleted, $username, $avatar); // данные пользователя
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);

  if (($status == 'readonly') or ($deleted == 1)){ //нельзя создавать сообщения нигде со статусом readonly/deleted
    $_SESSION['msg'] = 'Ваш статус не позволяет создавать сообщения на форуме.';
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=200');
    else header('Location: http://'.$GLOBALS['HostName'].'/?ai=200');
    exit();
  }

  if ($id_author != $_COOKIE['iduser']){
    $stmt = mysqli_prepare($GLOBALS['DB'], "SELECT listid FROM wblist WHERE id_from=? AND id_to=? LIMIT 1");
    mysqli_stmt_bind_param($stmt, 'ii', $id_author, intval($_COOKIE['iduser']));
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $listid); // данные ч/б списков
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);
  }else{
    $listid = 1; //мы сами у себя всегда в белом списке
  }

  if($listid == -1){ //нельзя создавать сообщения в топиках, где мы в чёрном списке
    $_SESSION['msg'] = 'Автор топика запретил Вам создавать сообщения.';
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=200');
    else header('Location: http://'.$GLOBALS['HostName'].'/?ai=200');  
    exit();
  }

  if (($type == 2) and ($status != 'readonly') and ($listid != 1)){//нельзя создавать сообщения в закрытых топиках если мы не в белом списке
    $_SESSION['msg'] = 'Автор топика не разрешил Вам создавать сообщения.';
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=200');
    else header('Location: http://'.$GLOBALS['HostName'].'/?ai=200');
    exit();
  }

  if (($msg > 0) and (empty($error))){ //если сообщение создаётся с цитатой, то берём текст из базы
    $stmt = mysqli_prepare($GLOBALS['DB'],
    'SELECT posts.text, users.name
     FROM posts LEFT JOIN users ON posts.id_author = users.iduser
     WHERE posts.id_msg=? AND posts.deleted=0 LIMIT 1');
    mysqli_stmt_bind_param($stmt, 'i', $msg); 
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $text, $authname);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);

    $message = '[q='.$authname.']'.$text.'[/q]';
  }

  $html = file_get_contents('./templates/msgform.html');
  $html = str_replace('{action}', './TryCreateNewMsg.php', $html);
  $html = str_replace('{butvalue}', 'Создать сообщение', $html);
  $html = str_replace('{topicname}', 'Новое сообщение в топике: '.$name, $html);
  $html = str_replace('{id_topic}', $id, $html);
  $html = str_replace('{error}', $error, $html);
  if (!empty($avatar)) //если аватар есть - выводим его
  $html = str_replace('{avatar}','<img src="./avatars/'.$avatar.'.jpg" alt="Аватар">', $html); 
  else $html = str_replace('{avatar}','', $html);
  $html = str_replace('{name}',$username, $html);
  $html = str_replace('{message}', $message, $html);

  return $html;
}
?>