<?php
function ShowUserAccountForm(){
  if ($GLOBALS['islogged']){ //если есть логин
    if (isset($_SESSION['AccountForm'])){ // если форма уже была заполнена но с ошибками, все данные берём из сессии
      $error = $_SESSION['AccountForm']['error'];
      $name = $_SESSION['AccountForm']['name'];
      $email = $_SESSION['AccountForm']['email'];
      $avatar = $_SESSION['AccountForm']['avatar'];
      $about = $_SESSION['AccountForm']['about'];
      $timezone = $_SESSION['AccountForm']['timezone'];
      $timeformat = $_SESSION['AccountForm']['timeformat'];
      $tpp = $_SESSION['AccountForm']['tpp'];
      $mpp = $_SESSION['AccountForm']['mpp'];
      $showonline = $_SESSION['AccountForm']['showonline'];
      $mailpmnotice = $_SESSION['AccountForm']['mailpmnotice'];
      $smscode = $_SESSION['AccountForm']['smscode'];
      $emailcode = $_SESSION['AccountForm']['emailcode'];
      unset($_SESSION['AccountForm']);
    }else{ //в противном случае все данные берём из базы
      $error = '';
      $stmt = mysqli_prepare($GLOBALS['DB'], "SELECT name, email, avatar, about, timezone, timeformat,
        tpp, mpp, showonline, mailpmnotice, smscode, emailcode FROM users WHERE user_hash=? LIMIT 1");
      mysqli_stmt_bind_param($stmt, 's', $_COOKIE['hash']);
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $name, $email, $avatar, $about, $timezone, $timeformat, $tpp, $mpp, $showonline, $mailpmnotice, $smscode, $emailcode);
      mysqli_stmt_fetch($stmt);
      mysqli_stmt_close($stmt);
    }
    //достаём email из базы, чтобы можно было выдать подсказку о риске повторной активации
    $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT email FROM users WHERE user_hash=? LIMIT 1');
    mysqli_stmt_bind_param($stmt, 's', $_COOKIE['hash']);
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $emailDB);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);

    if (isset($_SESSION['UpdateSuccess'])){
      $msg = $_SESSION['UpdateSuccess'];
      unset($_SESSION['UpdateSuccess']);
    }else{$msg = '';}

  }else{ //если куки нету
    $_SESSION['msg'] = 'Авторизуйтесь, чтобы редактировать настройки учётной записи.';
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=200');
      else header('Location: http://'.$GLOBALS['HostName'].'/?ai=200');  
    exit();
  }
 
  $html = file_get_contents('./templates/UserAccountForm.html');
  $html = str_replace('{error}', $error, $html);
  $html = str_replace('{tpp}', $tpp, $html);
  $html = str_replace('{mpp}', $mpp, $html);
  $html = str_replace('{msg}', $msg, $html);

  if (!empty($avatar)){
    $html = str_replace('{avatar}','<a title="Перейти на свою публичную страницу" href="./?ai=50&id='.$_COOKIE['iduser'].'"><img src="./avatars/'.$avatar.'.jpg" alt="Аватар">', $html);
    $html = str_replace('{delavatar}','<input type="button" value="удалить" onclick="ConfDel()" title="Удалить аватар" style="font-size: 15px; height: 23px">', $html);
  }else {
    $html = str_replace('{avatar}','', $html);
    $html = str_replace('{delavatar}','', $html);
  }

  $options = ''; //заполняем опции смещения серверного времени
  for ($i = -12; $i <= 12; $i++ ){
    if ($i < 1) $value = $i.' ч.';
    else $value = $i.' ч.';
    if ($i == $timezone) $options .= '<option value="'.$i.'" selected>'.$value.'</option>'."\n"; //$timezone = 0 по умолчанию
    else $options .= '<option value="'.$i.'">'.$value.'</option>'."\n";
  }
  $html = str_replace('{options}', $options, $html);
  $html = str_replace('{servertime}', date('H:i d.m.Y'), $html);
  $html = str_replace('{name}', $name, $html);
  $html = str_replace('{email}', $email, $html);
  $html = str_replace('{emaildb}', $emailDB, $html);
  $html = str_replace('{timeformat}', $timeformat, $html);
  $html = str_replace('{about}', $about, $html);

  if ($showonline) $html = str_replace('name="showonline"', 'name="showonline" checked', $html);
  if ($mailpmnotice) $html = str_replace('name="mailpmnotice"', 'name="mailpmnotice" checked', $html);

  if ($emailcode == 1)
  {$val = '<tr><td align="center"><div align="center"><img src="./pics/Ok.png" float="left">Учётная запись активирована по email</div></td></tr>';}
  else
  {$val = "<tr><td height='3px'></td></tr><tr><td align='center'><input type='button' value='Активировать по email' onClick='location.href=".'"./?ai=5"'."' style='font-size: 15px; width: 220px'></td></tr>";}
  $html = str_replace('{emailact}', $val, $html);

  if ($smscode == 1)
  {$val = '<tr><td align="center"><div align="center"><img src="./pics/Ok.png" float="left">Учётная запись активирована по телефону</div></td></tr>';}
  else
  {$val = "<tr><td height='10px'></td></tr><tr><td align='center'><input type='button' value='Активировать по Telegram' onClick='location.href=".'"./?ai=6"'."' style='font-size: 15px; width: 220px'></td></tr>";}
  $html = str_replace('{smsact}', $val, $html);

  return $html;
}
?>